#Simulacin distribucin Triangular

u<-runif(100)
x<-vector()
for (i in 1:length(u))
{
	if(u[i]<=0.5) x[i]=sqrt(2*u[i])
	else x[i]=2-sqrt(2*(1-u[i]))
}
par(mfrow=c(1,2))
hist(x,freq=F,xlim=c(-0.5,2.5),ylim=c(0,1),main="Histograma  de x",ylab="")
triang<-function(x)
{x*(0<x&x<=1)+(2-x)*(1<x&x<2)}
curve(triang(x),add=T,xlim=c(0,2),col=2,lwd=2)
ptriang<-function(x)
{x^2/2*(0<x&x<=1)+(1-((2-x)^2/2))*(1<x&x<2)+1*(x>=2&x<=Inf)}
curve(ptriang(x),xlim=c(0,2),col=2,lwd=2)
plot(ecdf(x),add=T)

#Contraste de Kolmogorov-Smirnov

ks.test(x,"ptriang")

#Contraste de Chi-cuadrado

cortes<-c(0,seq(0.5,1.5,by=0.25),Inf)
x.cut<-cut(x,cortes)
x.t<-table(x.cut)
length(x.t)
frobs=vector()
for(i in 1:length(x.t)) frobs[i]<-x.t[i]
sum(frobs)

#utilizacin de diff para chisq.test()

prob<-c(diff(ptriang(cortes[-7])),1-ptriang(cortes[6]))
chisq.test(x=frobs,p=prob)


