# generamos los puntos al azar x e y

x<-runif(100000,-1,1)
y<-runif(100000,-1,1)
plot(x,y)
munif1<-cbind(x,y)

# seleccionamos los puntos 
# en el interior de la circunferencia

munif2<-munif1[x^2+y^2<1,]
points(munif2,col="red")
curve(sqrt(1-x^2),xlim=c(-1,1),add=TRUE)
curve(-sqrt(1-x^2),xlim=c(-1,1),add=TRUE)
abline(v=0,lty=2)
abline(h=0,lty=2)

# estimacin del nmero pi

prob.est<-nrow(munif2)/nrow(munif1)
pi.est<-4*prob.est

# estimador como funcin para n puntos

estpi<-function(n)
{
x<-runif(n,-1,1)
y<-runif(n,-1,1)
munif1<-cbind(x,y)

# seleccionamos los puntos 
# en el interior de la circunferencia

munif2<-munif1[x^2+y^2<1,]
prob.est<-nrow(munif2)/nrow(munif1)
pi.est<-4*prob.est
}

# varias realizaciones

r<-vector()
for (i  in 1:200)
{
r[i]<-estpi(10000)
}

plot(r,type="l")
abline(h=pi,col="red")

# pasar lo anterior con ms observaciones

r2<-vector()
for (i  in 1:200)
{
r2[i]<-estpi(100000)
}
lines(seq(1:200),r2,col=2)
