#representacin grfica de las funciones

g1<-function(x) (asin(x)+exp(x))
curve(g1(x),xlim=c(0,1))

g2<-function(x) (g1(1/(1+x))*dexp(x))
curve(g2(x),xlim=c(0,10))

g3<-function(x) ((x+3)/(3*x^4+x^2+1))
curve(g3(x),xlim=c(-10,10))

curve(dnorm(x),add=TRUE,col="red")
curve(g3(x)/dnorm(x),xlim=c(-1,2))

#clculo de integrales con la funcin "integrate"

int1<-integrate(g1,0,1)
int2<-integrate(g2,0,Inf)
int3<-integrate(g3,-Inf,Inf)

#integracin Monte Carlo para g1

int1.f<-function(tama)
{
munif1<-runif(tama)
mean(g1(munif1))
}
#sucesivas aproximaciones con 1000 y 10000 simulaciones

int1.v<-vector(length=100)
for (i in 1:100) int1.v[i]<-int1.f(1000)
plot(int1.v,type="l")

int1.v2<-vector(length=100)
for (i in 1:100) int1.v2[i]<-int1.f(10000)
lines(seq(1:100),int1.v2,col=2)

abline(h=int1$value)

#integracin Monte Carlo para g2

int2.f<-function(tama)
{
mexp2<-rexp(tama)
mean(g1(1/(1+mexp2)))
}

#sucesivas aproximaciones con 1000 y 10000 simulaciones

int2.v<-vector(length=100)
for (i in 1:100) int2.v[i]<-int2.f(1000)
plot(int2.v,type="l")

int2.v2<-vector(length=100)
for (i in 1:100) int2.v2[i]<-int2.f(10000)
lines(seq(1:100),int2.v2,col=2)

abline(h=int2$value)

#con uniformes mediante un cambio de variable

int2.fB<-function(tama)
{
munif<-runif(tama)
mean(g1(munif)*exp(-((1/munif)-1))*(1/munif)^2)
}

#sucesivas aproximaciones con 1000 y 10000 simulaciones

int2.vB<-vector(length=100)
for (i in 1:100) int2.vB[i]<-int2.fB(1000)
lines(int2.vB,col=3)
int2.v2B<-vector(length=100)
for (i in 1:100) int2.v2B[i]<-int2.fB(10000)
lines(seq(1:100),int2.v2B,col=4)

#integracin Monte Carlo para g3

int3.f<-function(tama)
{
mnorm3<-rnorm(tama)
mean(g3(mnorm3)/dnorm(mnorm3))
}

#sucesivas aproximaciones con 1000 y 10000 simulaciones

int3.v<-vector(length=100)
for (i in 1:100) int3.v[i]<-int3.f(1000)
plot(int3.v,type="l")

int3.vB<-vector(length=100)
for (i in 1:100) int3.vB[i]<-int3.f(10000)
lines(seq(1:100),int3.vB,col=2)
abline(h=int3$value)

