# Muestreador de Gibbs

gibbs2<-function (n) 
{
        mat <- matrix(ncol = 2, nrow = n)
        x <- 10
        y <- 10
        mat[1, ] <- c(x, y)
        for (i in 2:n) {
                x <- rexp(1,rate=(1+y^2))
                y <- rnorm(1, 0, sqrt(1/(2*x)))
                mat[i, ] <- c(x, y)
        }
        mat
}

post1.b<-gibbs2(1000)

#muestra definitiva eliminando el calentamiento

post1<-post1.b[-c(1:100),]

#grficas para validar la simulacin

par(mfrow=c(3,2))
plot(post1,col=1:10000)
plot(post1,type="l")
plot(ts(post1[,1]))
plot(ts(post1[,2]))
hist(post1[,1],40,freq=F)
hist(post1[,2],40,freq=F)

#marginales

hist(post1[,1],40,freq=F)
curve(dgamma(x,shape=0.5),add=T)
hist(post1[,2],40,freq=F)
curve(dcauchy(x),add=T)

