#creamos la muestra de V1 y V2

x<-runif(100000,-1,1)
y<-runif(100000,-1,1)
plot(x,y)
munif1<-cbind(x,y)

#seleccionamos los puntos 
#en el interior del crculo

munif2<-munif1[x^2+y^2<1,]
points(munif2,col="red")
curve(sqrt(1-x^2),xlim=c(-1,1),add=TRUE)
curve(-sqrt(1-x^2),xlim=c(-1,1),add=TRUE)
abline(v=0,lty=2)
abline(h=0,lty=2)

#estimacin de pi por Monte Carlo
prob.est<-nrow(munif2)/nrow(munif1)
pi.est<-4*prob.est

#como funcin del nmero de puntos

estpi<-function(n)
{
x<-runif(n,-1,1)
y<-runif(n,-1,1)
munif1<-cbind(x,y)
#seleccionamos los puntos 
#en el interior del crculo
munif2<-munif1[x^2+y^2<1,]
prob.est<-nrow(munif2)/nrow(munif1)
pi.est<-4*prob.est
}

#realizacin de 200 estimaciones de pi
#con n=1000 puntos cada una

r<-vector()
for (i  in 1:200)
{
r[i]<-estpi(1000)
}
plot(r,type="l")
abline(h=pi,col="red")

#condicionamiento con Y=V1, 200 estimaciones de pi

muesV1<-matrix(nrow=1000,ncol=200)
for(i in 1:200)
muesV1[,i]<-sqrt(1-(runif(1000,-1,1)^2))
prob.est2<-apply(muesV1,2,mean)

#comparacin de los procedimientos

plot(r,type="l",lwd=2)
abline(h=pi,col="red",lwd=2)
lines(4*prob.est2,col="red",lwd=2)


